/*
 * read.c
 *
 *  Created on: 2021/5/24
 *      Author: ueyudiud
 */

#include "nffs.h"
#include "nffs_ext.h"
#include "nffs_node.h"

n_code nffsReadPage(n_file* fp, n_u32 off, void* dst, n_u32 len) {
	n_node_frag* frag = nffsLookupNode(fp, off);
	n_u32 end = off + len;
	n_u8* buf = dst;
	while (off < end) {
		if (nmfUnlikely(frag == NULL || frag->_off > off)) {
			n_u32 hole_end = end;
			if (frag != NULL && end > frag->_off)
				end = frag->_off;
			nmfLog(NMF_ENTITY_SELF, NMF_DBG_LEVEL_TRACE, "Filling frag hole from %d-%d\n",
				   off,
				   hole_end);
			memset(buf, 0, hole_end - off);
			buf += hole_end - off;
			off = hole_end;
		}
		else if (nmfUnlikely(frag->_ref == NULL)) { /* 没有在off位置的frag */
			uint32_t hole_end = nmfMin(end, frag->_off + frag->_len);
			nmfLog(NMF_ENTITY_SELF, NMF_DBG_LEVEL_TRACE, "Filling frag hole from %d-%d (frag 0x%x 0x%x)\n",
					  off,
					  hole_end,
					  frag->_off,
					  frag->_off + frag->_len);
			memset(buf, 0, hole_end - off);
			buf += hole_end - off;
			off = hole_end;
			frag = frag_next(frag);
		}
		else {
			n_u32 r_off = off - frag->_off;
			n_u32 r_len = nmfMin(frag->_len - r_off, end - off);

		}
	}
}
